unit uMain;

{$mode objfpc}{$H+}

interface

uses
  BGRABitmap, BGRABitmapTypes, Classes, SysUtils, FileUtil, Forms, Controls,
  Graphics, StdCtrls, ExtCtrls, Menus, Dialogs, ActnList, BGRAVirtualScreen,
  Windows, BCButton, BCPanel, BGRAImageList, BGRAResizeSpeedButton, types;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    BCButton1: TBCButton;
    BCButton10: TBCButton;
    BCButton11: TBCButton;
    BCButton12: TBCButton;
    BCButton13: TBCButton;
    BCButton14: TBCButton;
    BCButton15: TBCButton;
    BCButton2: TBCButton;
    BCButton3: TBCButton;
    BCButton4: TBCButton;
    BCButton5: TBCButton;
    BCButton6: TBCButton;
    BCButton7: TBCButton;
    BCButton8: TBCButton;
    BCButton9: TBCButton;
    btnNew: TBCButton;
    btnColors: TBCButton;
    btnClipboard: TBCButton;
    btnExit: TBCButton;
    btnUpDown: TBCButton;
    ImageListColors: TBGRAImageList;
    FileMenu: TBCPanel;
    BCPanel2: TBCPanel;
    btnFileMenuClose: TBGRAResizeSpeedButton;
    ImageList16: TBGRAImageList;
    Memo1: TMemo;
    mnuColorChange: TMenuItem;
    mnuColorPurple: TMenuItem;
    mnuColorPetrol: TMenuItem;
    mnuColorLiteBlue: TMenuItem;
    mnuColorOrange: TMenuItem;
    mnuColorRed: TMenuItem;
    mnuColorGreen: TMenuItem;
    pnlSettings2: TBCPanel;
    pnlEditClipboard: TBCPanel;
    pnlEdit2: TBCPanel;
    pnlHomeCommand: TBCPanel;
    ImageList32: TBGRAImageList;
    btnOpen: TBCButton;
    btnHelp: TBCButton;
    btnFileMenu: TBCButton;
    btnTabEdit: TBCButton;
    btnTabHome: TBCButton;
    btnTabSettings: TBCButton;
    pnlSettingsUI: TBCPanel;
    pnlHomeExit: TBCPanel;
    popColors: TPopupMenu;
    Splitter1: TSplitter;
    vsBody: TBGRAVirtualScreen;
    vsForm: TBGRAVirtualScreen;
    vsTab: TBGRAVirtualScreen;
    procedure btnExitClick(Sender: TObject);
    procedure btnOpenAfterRenderBCButton(Sender: TObject;
      const ABGRA: TBGRABitmap; AState: TBCButtonState; ARect: TRect);
    procedure btnFileMenuClick(Sender: TObject);
    procedure btnFileMenuCloseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure btnFileMenuMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure btnHelpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure btnTabHomeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure btnUpDownMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure FormCreate(Sender: TObject);
    procedure mnuColorChangeClick(Sender: TObject);
    procedure vsBodyRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure vsFormRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure vsTabRedraw(Sender: TObject; Bitmap: TBGRABitmap);
{
    procedure vsTitleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure vsTitleMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
}
  private
    { private declarations }
    procedure MoveAnimation(moveobj: TComponent; leftfrom: integer;
      leftto: integer; topfrom: integer; topto: integer);
  public
    { public declarations }
  end;

var
  frmMain: TfrmMain;
  TabColor: string;
{ TODO : Moveable Form without Title Caption
  MausPos: TPoint;
  xx, yy: integer;
}
implementation

{$R *.lfm}

uses
  uRibbon;

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
{ TODO : Loading / Saving of configuration -> TXMLConfig}

{ Default color = Blue }
  TabColor := 'blue';
  uRibbon.MainColor := $009A572A;        // Main Color
  uRibbon.TabFntColor := $009A572A;      // Tab Font Color Clicked
  uRibbon.TabNormalColor := $009A572A;   // Tab Button Normal
  uRibbon.TabHoverColor := $00b66d3e;    // Tab Button Hover
  uRibbon.TabClickedColor := $00F1F1F1;  // Tab Button Clicked
  uRibbon.ToolNormalColor := $009A572A;  // Tool Button Normal
  uRibbon.ToolHoverColor := $00b66d3e;   // Tool Button Hover
  uRibbon.ToolClickedColor := $00784012; // Tool Button Clicked

{ Colors of Buttons are the same for all styles }
  uRibbon.BtnFntColor := $00696969;      // Button Font Color
  uRibbon.BtnNormalColor := $00F1F1F1;   // Button Normal
  uRibbon.BtnHoverColor := $00cdcdcd;    // Button Hover
  uRibbon.BtnClickedColor := $00b0b0b0;  // Button Clicked

{ Apply styles to objects }
  RibbonMenu(btnFileMenu);

  RibbonTab(btnTabHome);
  RibbonTab(btnTabEdit);
  RibbonTab(btnTabSettings);

  RibbonTool(btnHelp);
  RibbonTool(btnUpDown);

  FileMenu.Background.Color := $009A572A;

  StyleRibbonBody(pnlHomeCommand);
  StyleRibbonBody(pnlHomeExit);
  StyleRibbonBody(pnlSettingsUI);
  StyleRibbonBody(pnlEditClipboard);
end;

procedure TfrmMain.mnuColorChangeClick(Sender: TObject);
var
  mnu: TMenuItem;
begin
  if (Sender is TMenuItem) then
  begin
    mnu := (Sender as TMenuItem);
    case mnu.Name of
      'mnuColorChange':
      begin
        TabColor := 'blue';
        uRibbon.MainColor := $009A572A;
        uRibbon.TabFntColor := $009A572A;
        uRibbon.TabNormalColor := $009A572A;
        uRibbon.TabHoverColor := $00b66d3e;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $009A572A;
        uRibbon.ToolHoverColor := $00b66d3e;
        uRibbon.ToolClickedColor := $00784012;
      end;
      'mnuColorGreen':
      begin
        TabColor := 'green';
        uRibbon.MainColor := $00477422;
        uRibbon.TabFntColor := $00477422;
        uRibbon.TabNormalColor := $00477422;
        uRibbon.TabHoverColor := $00679443;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $00477422;
        uRibbon.ToolHoverColor := $00679443;
        uRibbon.ToolClickedColor := $00395d1b;
      end;
      'mnuColorRed':
      begin
        TabColor := 'red';
        uRibbon.MainColor := $003a37a4;
        uRibbon.TabFntColor := $003a37a4;
        uRibbon.TabNormalColor := $003a37a4;
        uRibbon.TabHoverColor := $005956c7;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $003a37a4;
        uRibbon.ToolHoverColor := $005956c7;
        uRibbon.ToolClickedColor := $002e2c83;
      end;
      'mnuColorOrange':
      begin
        TabColor := 'orange';
        uRibbon.MainColor := $002a47b7;
        uRibbon.TabFntColor := $002a47b7;
        uRibbon.TabNormalColor := $002a47b7;
        uRibbon.TabHoverColor := $003959dc;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $002a47b7;
        uRibbon.ToolHoverColor := $003959dc;
        uRibbon.ToolClickedColor := $00223992;
      end;
      'mnuColorLiteBlue':
      begin
        TabColor := 'lightblue';
        uRibbon.MainColor := $00c77301;
        uRibbon.TabFntColor := $00c77301;
        uRibbon.TabNormalColor := $00c77301;
        uRibbon.TabHoverColor := $00d48a2a;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $00c77301;
        uRibbon.ToolHoverColor := $00d48a2a;
        uRibbon.ToolClickedColor := $009f5c01;
      end;
      'mnuColorPetrol':
      begin
        TabColor := 'petrol';
        uRibbon.MainColor := $00728200;
        uRibbon.TabFntColor := $00728200;
        uRibbon.TabNormalColor := $00728200;
        uRibbon.TabHoverColor := $00839900;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $00728200;
        uRibbon.ToolHoverColor := $00839900;
        uRibbon.ToolClickedColor := $005f6b1a;
      end;
      'mnuColorPurple':
      begin
        TabColor := 'purple';
        uRibbon.MainColor := $007b3980;
        uRibbon.TabFntColor := $007b3980;
        uRibbon.TabNormalColor := $007b3980;
        uRibbon.TabHoverColor := $009e56a3;
        uRibbon.TabClickedColor := $00F1F1F1;
        uRibbon.ToolNormalColor := $007b3980;
        uRibbon.ToolHoverColor := $009e56a3;
        uRibbon.ToolClickedColor := $00622e66;
      end;
    end;
    RibbonMenu(btnFileMenu);

    RibbonTab(btnTabHome);
    RibbonTab(btnTabEdit);
    RibbonTab(btnTabSettings);

    RibbonTool(btnHelp);
    RibbonTool(btnUpDown);

    vsTab.RedrawBitmap;
    vsForm.RedrawBitmap;
    btnFileMenu.Repaint;

    StyleRibbonBody(vsBody);

{ TODO : Applying color settings to file menu
//    FileMenu.Background.Color:=uRibbon.MainColor;
//    Splitter1.Color:=uRibbon.MainColor;
}
  end;

end;

{ Animation of objects (c) Lazplanet
http://lazplanet.blogspot.de/2013/05/animate-move-of-object.html}
procedure TfrmMain.MoveAnimation(moveobj: TComponent; leftfrom: integer;
  leftto: integer; topfrom: integer; topto: integer);
var
  i: integer;
  step: integer = 5;
  moveareax, moveareay: integer;
begin
  i := 1;
  moveareax := leftto - leftfrom;
  moveareay := topto - topfrom;
  while i <= 10 do
  begin
    TButton(moveobj).Left := round(leftfrom + (moveareax * i / 10));
    TButton(moveobj).Top := round(topfrom + (moveareay * i / 10));
    Repaint;
    Sleep(1);
    // we exit the while...do loop when our work is done
    if i >= 10 then
      Exit;
    Inc(i, step);
    if (10 - i) < step then
      i := 10;
  end;
end;

procedure TfrmMain.btnOpenAfterRenderBCButton(Sender: TObject;
  const ABGRA: TBGRABitmap; AState: TBCButtonState; ARect: TRect);
var
  myText: string;
  ts: TSize;
begin
{ Custom painting of Caption and Image needed, as standard routines misalign the
  position of Caption and Image}
  TBCButton(Sender).ShowCaption := False;
  ABGRA.FontName := 'Segoe UI';
  ABGRA.FontHeight := 13;
  myText := TBCButton(Sender).Caption;
  ts := ABGRA.TextSize(mytext);
{ TODO : Line break if Caption wider than Object width }
  ABGRA.TextOut((TBCButton(Sender).Width - ts.cx) div 2,
    TBCButton(Sender).Height - 28, myText, uRibbon.BtnFntColor);
{
ImageList.Draw(ACanvas: TCanvas; AX, AY, AIndex: Integer;
 AEnabled: Boolean = True);
}
  ImageList32.Draw(ABGRA.Bitmap.Canvas, (TBCButton(Sender).Width - 32) div 2, 4,
    TBCButton(Sender).ImageIndex);

end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.btnFileMenuClick(Sender: TObject);
begin
  FileMenu.Show;
  MoveAnimation(FileMenu, -FileMenu.Width, 0, 1, 0);
end;

procedure TfrmMain.btnFileMenuCloseMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  FileMenu.Hide;
end;

procedure TfrmMain.btnFileMenuMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  FileMenu.Show;
  MoveAnimation(FileMenu, -FileMenu.Width, 0, 1, 0);
end;

procedure TfrmMain.btnHelpMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  MessageDlg('About',
    'BGRA Ribbon' + Chr(13) + Chr(10) + 'Made with Lazarus, Icons from Icons8' +
    Chr(13) + Chr(10) + '(c) 2016, coasting',
    mtInformation, [mbOK], 0);
end;

procedure TfrmMain.btnTabHomeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  tab: TBCButton;
begin
  if not (vsBody.Visible) then
  begin
    vsBody.Show;
    btnUpDown.ImageIndex := 12;
    Memo1.Top := Memo1.Top + vsBody.Height;
    Memo1.Height := Memo1.Height - vsBody.Height;
  end;
  if (Sender is TBCButton) then
  begin
    tab := (Sender as TBCButton);
    frmMain.DisableAutoSizing; //reduce flicker
    case tab.Name of
      'btnTabHome':
      begin
        btnTabHome.Down := True;
        btnTabEdit.Down := False;
        btnTabSettings.Down := False;
        pnlHomeCommand.Show;
        pnlHomeExit.Show;
        pnlEditClipboard.Hide;
        pnlEdit2.Hide;
        pnlSettingsUI.Hide;
        pnlSettings2.Hide;
      end;
      'btnTabEdit':
      begin
        btnTabHome.Down := False;
        btnTabEdit.Down := True;
        btnTabSettings.Down := False;
        pnlHomeCommand.Hide;
        pnlHomeExit.Hide;
        pnlSettingsUI.Hide;
        pnlSettings2.Hide;
        pnlEditClipboard.Show;
        pnlEdit2.Show;
      end;
      'btnTabSettings':
      begin
        btnTabHome.Down := False;
        btnTabEdit.Down := False;
        btnTabSettings.Down := True;
        pnlHomeCommand.Hide;
        pnlHomeExit.Hide;
        pnlEditClipboard.Hide;
        pnlEdit2.Hide;
        pnlSettingsUI.Show;
        pnlSettings2.Show;
      end;
    end;
    frmMain.EnableAutoSizing; //reduce flicker
  end;
end;

procedure TfrmMain.btnUpDownMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  if vsBody.Visible then
  begin
{ TODO : Animation
//    MoveAnimation(vsBody, -vsBody.Height, 0, 1, 0);
}
    vsBody.Hide;
    btnUpDown.ImageIndex := 13;
    Memo1.Top := Memo1.Top - vsBody.Height;
    Memo1.Height := Memo1.Height + vsBody.Height;
  end
  else
  begin
    vsBody.Show;
    btnUpDown.ImageIndex := 12;
    Memo1.Top := Memo1.Top + vsBody.Height;
    Memo1.Height := Memo1.Height - vsBody.Height;
  end;
end;

procedure TfrmMain.vsBodyRedraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  DrawBodyGradient(Bitmap);
end;

procedure TfrmMain.vsFormRedraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  DrawFormGradient(Bitmap);
end;

procedure TfrmMain.vsTabRedraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  DrawTabGradient(Bitmap);
end;

{ TODO : Moveable / Sizeable Form without Title Caption
  vsTitle = TBGRAVirtualScreen

procedure TfrmMain.vsTitleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  GetCursorPos(MausPos);
  xx := mauspos.x - frmMain.Left;
  yy := mauspos.y - frmMain.Top;
end;

procedure TfrmMain.vsTitleMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin
  if ssLeft in Shift then
  begin
    GetCursorPos(MausPos);
    frmMain.Left := mauspos.x - xx;
    frmMain.Top := mauspos.y - yy;
  end;
end;
}

end.


